# std::enable_shared_from_this<T>::shared_from_this

From cppreference.com
< cpp‎ | memory‎ | enable shared from this

std::shared_ptr <T> shared_from_this(); | (1) | (since C++11)
std::shared_ptr <T const> shared_from_this() const; | (2) | (since C++11)

Returns a std::shared_ptr <T> that shares ownership of *this with all existing std::shared_ptr that refer to *this.

### Return value

std::shared_ptr <T>(`weak_this`﻿)

### Exceptions

If `shared_from_this` is called on an object that is not previously shared by std::shared_ptr, std::bad_weak_ptr is thrown by the std::shared_ptr constructor.

### Example

Run this code

    #include <iostream>
    #include <memory>

    struct Foo : public std::enable_shared_from_this<Foo>
    {
        Foo() { std::cout << "Foo::Foo\n"; }
        ~Foo() { std::cout << "Foo::~Foo\n"; }
        std::shared_ptr<Foo> getFoo() { return shared_from_this(); }
    };

    int main()
    {
        Foo *f = new Foo;
        std::shared_ptr<Foo> pf1;

        {
            std::shared_ptr<Foo> pf2(f);
            pf1 = pf2->getFoo(); // shares ownership of object with pf2
        }

        std::cout << "pf2 is gone\n";
    }

Output:

    Foo::Foo
    pf2 is gone
    Foo::~Foo

### See also

shared_ptr (C++11) | smart pointer with shared object ownership semantics (class template)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/memory/enable_shared_from_this/shared_from_this&oldid=177229"